Subject: memcached backend: Remove tagIndex
Description
Problem:
The memcached backend implementation currenty stores this key-value "structure" to map our identifier-data-keys relation:
    -  identifier -> data
    -  identifier -> keys
    -  key -> identifiers
    -  tagIndex -> All known tags

The tagIndex doesn't have any benefit at all, it just leads to more set() and get() calls.

Solution:
Completly remove tagIndex to save some operations which speeds up this backend, unit tests still show green bar.

Numbers:
Performance tests show that the backend speeds up between ~10 to 100% by removing the tagIndex. As an example, attached
images show a test which set()'s a raising number of cache entries with a single attached tag to the backend. More numbers can be
generated with ext:enetcacheanalytics (forge) in v4.

Notes:
Memcache is a simple key-value store and not designed to store structures of multiple related entries. Our implementation is a
misuse, which leads to corrupt caches if memcache evicts entries from cache (because it needs space for new elements), or if single
servers fail in a multi server environment.

Associated revisions
Revision 924bf567 - 2010-08-23 16:08 - Karsten Dambekalns

[+BUGFIX] FLOW3 (Cache): Removed tagIndex from memcache and APC backends, fixes #8918. Thanks to Christian Kuhn.

Change-Id: I6ee52676aa5db78bfa5410b296c94e99d5c41c1a

History
#1 - 2010-08-12 18:00 - Karsten Dambekalns
- Status changed from New to Accepted
- Assigned To set to Karsten Dambekalns
- Start date deleted (2010-07-17)

#2 - 2010-08-16 11:22 - Karsten Dambekalns
- Target version set to 1.0 alpha 11
- Start date set to 2010-08-16
#3 - 2010-08-16 11:35 - Karsten Dambekalns
- Status changed from Accepted to Resolved
- % Done changed from 0 to 100

Applied in changeset r4974.
